public class ProducerConsumer {
	public static void main(String args[]) {
		BufferInterface buffer = new BufferWithYield(); //uses yield
		
		//BufferInterface buffer = new BufferWithSpinlock(); //uses no-op 
		
		//BufferInterface buffer = new BufferWithoutNotify(); //no notify
		
		//BufferInterface buffer = new Buffer(); //correct implementation
		
		Producer producer = new Producer(buffer);
		Consumer consumer = new Consumer(buffer);
        
		producer.start();
		consumer.start();
       
	}
}
