public class Buffer implements BufferInterface {
	private final int BUFFER_SIZE = 5; private int count = 0;
	private Object buffer[] = new Object[BUFFER_SIZE];
	private int in = 0; private int out = 0;

	//put() called by producer
	public synchronized void put(Object item) {
		try {
			while (count == BUFFER_SIZE)
				wait();//Thread.yield();
		} catch(InterruptedException iex) {}
		++count;
		buffer[in] = item;
		in = (in + 1) % BUFFER_SIZE;
		notify();
	}

	//take() called by consumer
	public synchronized Object take() {
		Object  item;
		try {
			while (count == 0)
				wait();//Thread.yield();
		} catch (InterruptedException iex) {}
		--count;
		item = buffer[out];
		out = (out + 1) % BUFFER_SIZE;
		notify();
		return item;
	}
}
